<template>
    <div class="card form-card">
        <div>
            <form>
                <div class="card-header">
                    <h3>{{title}}</h3>
                </div>
                <div class="card-body">
                    <p v-if="error.length" class="error">
                    <ul>
                        <li v-for="(err, key) in error" :key="key">{{ err }}</li>
                    </ul>
                </p>
                <label> Tiêu đề </label>
                <input type="text" class="form-control" v-model="post.title" name="title" v-bind="title">
                <label> Mô tả ngắn </label>
                <input class="form-control" v-model="post.des">
                <label> Chi tiết </label>
                <textarea class="form-control" id="deatil" v-model="post.detail"></textarea>
                <div class="form-group">
                    <label for="exampleFormControlFile1">Hình ảnh</label>
                    <input type="file" class="form-control-file" id="exampleFormControlFile1" >
                </div>
                <div class="form-group col-md-3">
                    <label for="inputState">Loại</label>
                    <select id="inputState" class="form-control" v-model="post.category" >
                        <option value="" disabled>Chọn loại</option>
                        <option v-for="item in CATEGORIES" :key="item.id" :value="item.id">{{ item.name }}</option>
                    </select>
                </div>
                <div class="form-group location col-md-3">
                    <lable> Vị trí </lable>
                    <div v-for="item in POSITIONS" :key="item.id">
                        <input type="checkbox"  name="position" :value="item.id" v-model="post.position"/>
                        <label>{{ item.name }}</label>
                    </div> 
                </div>
                <div class="public col-md-3">
                    <label>Public</label>
                    <div>
                        <input type="radio" name="public" value="true" v-model="post.public"/> Yes
                    </div>
                    <div>
                        <input type="radio" name="public" value="false" v-model="post.public"/> No
                    </div>
                </div>
                <div class="public-date col-md-3">
                    <lable>Date Public</lable>
                    <input type="date" name="" v-model="post.data_pubblic" />
                </div>
                </div>
                <div class="btn col-12 card-footer">
                    <button type="submit" class="btn btn-success" @click.prevent="submitData">Submit</button>
                    <button type="button" class="btn btn-primary" @click="clearForm()">Clear</button>
                </div>
            </form>
        </div>
    </div>
</template>

<script>
import {CATEGORIES, POSITIONS, BASE_API} from '../constant/constantSystem.js';
export default {
    props: ["post", "title", "edit"],
    data: function(){
        return {
            error:[],
        };
    },

    computed: {
        CATEGORIES()
        {
            return CATEGORIES
        },

        POSITIONS()
        {
            return POSITIONS
        },

        BASE_API()
        {
            return BASE_API
        },
    },

    methods: {
        async updateBlog(post) {
            if(post){
                alert('Cập nhật thành công')
                var url = BASE_API + this.post.id;
                const response = await this.$axios.$put(url, post);
                this.$router.push('list')
            }
        },

        submitData: function(){
            this.error = [];

            if (!this.post.title) {
                this.error.push('Vui lòng điền Title.');
                console.log(this.error);
            }
            if (!this.post.des) {
                this.error.push('Vui lòng mô tả.');
                console.log(this.error);
            }
            if (!this.post.detail) {
                this.error.push('Vui lòng điền chi tiết.');
                console.log(this.error);
            }
            if (!this.post.category) {
                this.error.push('Vui lòng chọn loại.');
                console.log(this.error);
            }
            if (!this.post.position) {
                this.error.push('Vui lòng chọn vị trí.');
                console.log(this.error);
            }
            if (!this.post.public) {
                this.error.push('Vui lòng chọn public.');
                console.log(this.error);
            }
            if (!this.post.data_pubblic) {
                this.error.push('Vui lòng chọn ngày public.');
                console.log(this.error);
            }
            if (!this.error.length){
            var positions = new Array(this.post.position);
            positions = positions[0].map(function (item) {
            return parseInt(item);
            });
            var post = {
                title: this.post.title,
                des: this.post.des,
                detail: this.post.detail,
                image: this.post.image,
                category: this.post.category,
                position: positions,
                public: this.post.public,
                data_pubblic: this.post.data_pubblic,
            };

            if (this.edit) {
                this.updateBlog(post);
            } else {
                this.createBlog(post);
            }
            }
        },

        async createBlog(post) {
            const response = await this.$axios.$post(BASE_API,post);
        },
        
        clearForm() {
            this.post = {
                title: "",
                des: "",
                detail: "",
                image: "",
                category: "",
                position: [""],
                public: false,
                data_pubblic: "",
            };
        },
    },
}
</script>
<style>
    .error {
        color:red;
    }
    #deatil {
        height: 40vh;
    }
    .form-card {
        margin-top:3vh;
        margin-bottom: 3vh;
    }
</style>